/*
* PROJECT: Happy New Year
* VERSION: 1.0
* AUTHOR: Mattias Thell
* URL: http://www.mattiasthell.com
*
* */

#pragma once
#include "Actor.hpp"

#include <hgeparticle.h>
#include <boost/shared_ptr.hpp>

namespace hny 
{
	typedef boost::shared_ptr<hgeParticleSystem> ParticlePtr;
	typedef boost::shared_ptr<hgeSprite> SpritePtr;

	class Explosion :
		public hny::Actor
	{
	public:
		Explosion(World* world, hgeVector position, int combo, float velocity, float radius);
		virtual ~Explosion();

		virtual void Update(float dt);
		virtual void Draw();

		int GetCombo();

	private:

		ParticlePtr mParticleSystem;

		SpritePtr mRadiusSprite;
		float mSpriteAlpha;
		float mStartingAlpha;

		float mVelocity;

		float mMaxRadius;

		float mAge;

		int mCombo;
	};

}